package de.jaetzold.art;

/**	An interface for classes decribing groups of SensorEvents.
	It is not really used by now because only one implementing class exists and a standard-Sensor does not have any methods for using it.
	However it can be used in conjunction with RawSensor and probably it's subclasses to block specific Events from being delivered to some listeners.
	@see Sensor
	@see RawSensor
	*/
public interface SensorEventDescriptor {
	/**	Tells whether the given SensorEvent is in the group described by this SensorEventDescriptor.
		*/
	public boolean describes(SensorEvent event);
}
