package de.jaetzold.art;

/** A subclass of Number which has the same value as the target SensorEvent.
	@see SensorEvent
	*/
public class SensorEventNumber extends Number {
	private SensorEvent targetEvent;
	/**	Constructs a new Number-Object which has the same value as target.
		*/
	public SensorEventNumber(SensorEvent target) {
		this.targetEvent = target;
	}
	
	public byte byteValue() {
		return (byte)intValue();
	}
	public short shortValue() {
		return (byte)intValue();
	}
	public int intValue() {
		return targetEvent.getIntValue();
	}
	public long longValue() {
		return (long)targetEvent.getValue();
	}
	public float floatValue() {
		return (float)doubleValue();
	}
	public double doubleValue() {
		return targetEvent.getValue();
	}
}
