package de.jaetzold.art.examples;

import de.jaetzold.art.Motor;
import de.jaetzold.art.RobotInterface;
// BEGIN DriveTrain:msrobot
public class DriveTrainSimpleMSDemoRobot
									extends DriveTrainSimpleRobot
{
	public DriveTrainSimpleMSDemoRobot(RobotInterface iface) {
		super(iface);
		// the Motors on the MS-Robot are on different sides
		Motor tmp = leftMotor;
		leftMotor = rightMotor;
		rightMotor = tmp;
		// the Motors on the MS-Robot turn the other way round
		leftMotor.setReversed(true);
		rightMotor.setReversed(true);
	}
	public DriveTrainSimpleMSDemoRobot(String interfacePortName) {
		this(new de.jaetzold.art.RobotInterfaceFactory()
									.getInterface(interfacePortName));
	}
	public DriveTrainSimpleMSDemoRobot() {
		this(System.getProperty(className +".portName", "MS"));
	}
	private static String className =
			"de.jaetzold.art.examples.DriveTrainSimpleMSDemoRobot";
// ...
	public static void main(String[] argv) {
		if(argv.length > 0) {
			System.setProperty(className +".portName", argv[0]);
		}
		DriveTrainSimpleRobot robot = new DriveTrainSimpleMSDemoRobot();

		DriveTrain driveTrain = new DriveTrainSimpleAlgorithm(robot);
		
		DriveTrainView view = new DriveTrainView(driveTrain);
		DriveTrainCommands commands = new DriveTrainCommands(driveTrain);
		
		java.awt.Frame f = new java.awt.Frame(className);
		f.setLayout(new java.awt.BorderLayout());
		f.add("North", view);
		f.add("South", commands);
		
		f.addWindowListener(
			new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent we) {
					System.exit(0);
				}
			}
		);
		f.pack();
		f.show();
	}
// ...
}
// END DriveTrain:msrobot
