// BEGIN DriveTrain:view
package de.jaetzold.art.examples;

import java.awt.Panel;
import java.awt.TextField;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

public class DriveTrainView extends Panel
							implements PropertyChangeListener
{
	protected TextField stateOutput = new TextField("", 15);
	
	public void propertyChange(PropertyChangeEvent pce) {
		if(pce.getSource() instanceof DriveTrain
				&& pce.getPropertyName().equals("state")
				&& pce.getNewValue() instanceof Number) {
			
			String stateName = "";
			int state = ((Number)pce.getNewValue()).intValue();
			switch(state & ~ DriveTrain.STOP) {
				case DriveTrain.FORWARD:
					stateName = "forward";
					break;
// ...
				case DriveTrain.BACKWARD:
					stateName = "backward";
					break;
				case DriveTrain.LEFT_SPIN:
					stateName = "left spin";
					break;
				case DriveTrain.RIGHT_SPIN:
					stateName = "right spin";
					break;
// ...
				default:
					stateName = "";
			}
			if((state & DriveTrain.STOP) == DriveTrain.STOP) {
				stateName = "stop " +stateName;
			}
			stateOutput.setText(stateName);
		}
	}
// ...
	public DriveTrainView() {
		stateOutput.setEditable(false);
		add(stateOutput);
	}
	public DriveTrainView(DriveTrain dt) {
		this();
		// for convenience, the View can add itself as a PropertyChangeListener
		de.jaetzold.util.BeanSupport.addPropertyChangeListenerFor(dt, this);
	}
// ...
}
// END DriveTrain:view
