package de.jaetzold.art.examples;

import de.jaetzold.art.RobotInterface;

public class NormalizedDriveTrainSimpleAWTDemoRobot
					extends NormalizedDriveTrainSimpleBaseRobot
{
	public NormalizedDriveTrainSimpleAWTDemoRobot(RobotInterface iface)
	{
		// just some fake-values which are big enough to notice something
		super(new DriveTrainSimpleRobot(iface), 20000, 20000);
	}
// ...
	public NormalizedDriveTrainSimpleAWTDemoRobot(String interfacePortName) {
		this(new de.jaetzold.art.RobotInterfaceFactory()
									.getInterface(interfacePortName));
	}
	public NormalizedDriveTrainSimpleAWTDemoRobot() {
		this(System.getProperty(className +".portName", "AWT"));
	}
	private static String className =
			"de.jaetzold.art.examples.NormalizedDriveTrainSimpleAWTDemoRobot";
	public static void main(String[] argv) {
		if(argv.length > 0) {
			System.setProperty(className +".portName", argv[0]);
		}
		NormalizedDriveTrainSimpleAlgorithm.Robot robot =
							new NormalizedDriveTrainSimpleAWTDemoRobot();
		NormalizedDriveTrain driveTrain =
							new NormalizedDriveTrainSimpleAlgorithm(robot);
		
		DriveTrainView view = new DriveTrainView(driveTrain);
		NormalizedDriveTrainCommands commands =
							new NormalizedDriveTrainCommands(driveTrain);
		
		java.awt.Frame f = new java.awt.Frame(className);
		f.setLayout(new java.awt.BorderLayout());
		f.add("North", view);
		f.add("South", commands);
		
		f.addWindowListener(
			new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent we) {
					System.exit(0);
				}
			}
		);
		f.pack();
		f.show();
	}
// ...
}
