package de.jaetzold.art.examples;

import de.jaetzold.art.Motor;

public class NormalizedDriveTrainSimpleBaseRobot
					implements NormalizedDriveTrainSimpleAlgorithm.Robot
{
	protected DriveTrainSimpleAlgorithm.Robot robot;
	protected int meterMilliseconds;
	protected int fullTurnMilliseconds;
	
	public NormalizedDriveTrainSimpleBaseRobot(
										DriveTrainSimpleAlgorithm.Robot robot,
										int meterMilliseconds,
										int fullTurnMilliseconds)
	{
		this.robot = robot;
		this.meterMilliseconds = meterMilliseconds;
		this.fullTurnMilliseconds = fullTurnMilliseconds;
	}
	
	public Motor getLeftMotor() {
		return robot.getLeftMotor();
	}
	
	public Motor getRightMotor() {
		return robot.getRightMotor();
	}
	
	public int getMeterMilliseconds() {
		return meterMilliseconds;
	}
	
	public int getFullTurnMilliseconds() {
		return fullTurnMilliseconds;
	}
// ...
	public NormalizedDriveTrainSimpleBaseRobot() throws Exception {
		this((DriveTrainSimpleAlgorithm.Robot)
			Class.forName(
				System.getProperty(
					className +".robotClass",
					"de.jaetzold.art.examples.DriveTrainSimpleRobot"
				)
			).newInstance(),
			Integer.parseInt(
				System.getProperty(className +".meterMilliseconds", "1000")),
			Integer.parseInt(
				System.getProperty(className +".fullTurnMilliseconds", "1000")
			)
		);
	}
	private static String className =
			"de.jaetzold.art.examples.NormalizedDriveTrainSimpleBaseRobot";
	public static void main(String[] argv) throws Exception {
		if(argv.length > 0) {
			System.setProperty(className +".robotClass", argv[0]);
		}
		new NormalizedDriveTrainSimpleBaseRobot();
	}
// ...
}
