package de.jaetzold.art.examples;

import de.jaetzold.art.RobotInterface;

public class NormalizedDriveTrainSimpleFTDemoRobot
					extends NormalizedDriveTrainSimpleBaseRobot
{
	public NormalizedDriveTrainSimpleFTDemoRobot(RobotInterface iface)
	{
		// FT fits with standard-implementation of DriveTrainSimpleRobot
		super(new DriveTrainSimpleRobot(iface), 7500, 2700);
		/*super(new DriveTrainSimpleRobot(iface), 15000, 6000);
		// but let the motors move a bit slower:
		robot.getLeftMotor().setPower(0.6);
		robot.getRightMotor().setPower(0.6);*/
	}
// ...
	public NormalizedDriveTrainSimpleFTDemoRobot(String interfacePortName) {
		this(new de.jaetzold.art.RobotInterfaceFactory()
									.getInterface(interfacePortName));
	}
	public NormalizedDriveTrainSimpleFTDemoRobot() {
		this(System.getProperty(className +".portName", "FT"));
	}
	private static String className =
			"de.jaetzold.art.examples.NormalizedDriveTrainSimpleFTDemoRobot";
	public static void main(String[] argv) {
		if(argv.length > 0) {
			System.setProperty(className +".portName", argv[0]);
		}
		NormalizedDriveTrainSimpleAlgorithm.Robot robot =
							new NormalizedDriveTrainSimpleFTDemoRobot();
		NormalizedDriveTrain driveTrain =
							new NormalizedDriveTrainSimpleAlgorithm(robot);
		
		DriveTrainView view = new DriveTrainView(driveTrain);
		NormalizedDriveTrainCommands commands =
							new NormalizedDriveTrainCommands(driveTrain);
		
		java.awt.Frame f = new java.awt.Frame(className);
		f.setLayout(new java.awt.BorderLayout());
		f.add("North", view);
		f.add("South", commands);
		
		f.addWindowListener(
			new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent we) {
					System.exit(0);
				}
			}
		);
		f.pack();
		f.show();
	}
// ...
}
