package de.jaetzold.art.examples;

import de.jaetzold.art.RobotInterface;

public class SubsumptionTrustyAWTDemoRobot extends SubsumptionTrustyBaseRobot {
	public SubsumptionTrustyAWTDemoRobot(Trusty trusty, RobotInterface iface) {
		super(trusty, iface);
	}
	public SubsumptionTrustyAWTDemoRobot(RobotInterface iface) {
		this(new TrustySimpleAlgorithm(
				new TrustySimpleAWTDemoRobot(iface)
			), iface);
	}
// ...
	public SubsumptionTrustyAWTDemoRobot() throws Exception {
		this(new de.jaetzold.art.RobotInterfaceFactory().getInterface(
				System.getProperty(className +".portName", "AWT")
			)
		);
	}
	private static String className =
			"de.jaetzold.art.examples.SubsumptionTrustyAWTDemoRobot";
	public static void main(String[] argv) throws Exception {
		if(argv.length > 0) {
			System.setProperty(className +".portName", argv[0]);
		}
		SubsumptionTrusty.Robot robot = new SubsumptionTrustyAWTDemoRobot();
		SubsumptionTrusty trusty = new SubsumptionTrusty(robot);
		trusty.getSchedulerPerformer().start();	// start subsumption
		
		TrustyView view = new TrustyView(trusty);
		
		TrustyCommands commands = new TrustyCommands(trusty);
		
		java.awt.Frame f = new java.awt.Frame(className);
		f.setLayout(new java.awt.BorderLayout());
		f.add("North", view);
		f.add("South", commands);
		
		f.addWindowListener(
			new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent we) {
					System.exit(0);
				}
			}
		);
		f.pack();
		f.show();
	}
// ...
}
