package de.jaetzold.art.examples;

import de.jaetzold.art.BooleanSensor;
import de.jaetzold.art.RobotInterface;
import de.jaetzold.art.SensorPort;

public class SubsumptionTrustyBaseRobot implements SubsumptionTrusty.Robot {
	protected Trusty trusty;
	protected BooleanSensor leftSensor;
	protected BooleanSensor rightSensor;
// BEGIN SubTrusty:robot:impl	
	public SubsumptionTrustyBaseRobot(  Trusty trusty,
										RobotInterface iface)
	{
		this.trusty = trusty;
		
		SensorPort[] ports = iface.getSensorPorts();
		if(ports.length < 2) {
			throw new IllegalArgumentException("RobotInterface " +iface
												+" provides only "
												+ports.length
												+" SensorPorts"
												+", minimum is 2.");
		}
		
		leftSensor = new BooleanSensor();
		leftSensor.connectWith(ports[0]);
		
		rightSensor = new BooleanSensor();
		rightSensor.connectWith(ports[1]);
	}
// END SubTrusty:robot:impl	
	public Trusty getTrusty() {
		return trusty;
	}
	public BooleanSensor getLeftSensor() {
		return leftSensor;
	}
	public BooleanSensor getRightSensor() {
		return rightSensor;
	}
// ...
	public SubsumptionTrustyBaseRobot() throws Exception {
		this((Trusty)Class.forName(
				System.getProperty(
					className +".trustyClass",
					"de.jaetzold.art.examples.TrustySimpleAlgorithm"
				)
			).newInstance(),
			new de.jaetzold.art.RobotInterfaceFactory().getInterface(
				System.getProperty(className +".portName")
			)
		);
	}
	private static String className =
			"de.jaetzold.art.examples.SubsumptionTrustyBaseRobot";
	public static void main(String[] argv) throws Exception {
		if(argv.length > 0) {
			System.setProperty(className +".portName", argv[0]);
		}
		new SubsumptionTrustyBaseRobot();
	}
// ...
}
	
