package de.jaetzold.art.examples;

import de.jaetzold.art.RobotInterface;

public class TrustySimpleFTDemoRobot extends TrustySimpleBaseRobot {
	public TrustySimpleFTDemoRobot(NormalizedDriveTrain driveTrain) {
		super(driveTrain, 0.1, 0.05);
	}
	public TrustySimpleFTDemoRobot(RobotInterface iface) {
		this(new NormalizedDriveTrainSimpleAlgorithm(
					new NormalizedDriveTrainSimpleFTDemoRobot(iface)
				)
			);
	}
// ...
	public TrustySimpleFTDemoRobot(String interfacePortName) {
		this(new de.jaetzold.art.RobotInterfaceFactory()
									.getInterface(interfacePortName));
	}
	public TrustySimpleFTDemoRobot() {
		this(System.getProperty(className +".portName", "FT"));
	}
	private static String className =
			"de.jaetzold.art.examples.TrustySimpleFTDemoRobot";
	public static void main(String[] argv) {
		if(argv.length > 0) {
			System.setProperty(className +".portName", argv[0]);
		}
		TrustySimpleAlgorithm.Robot robot = new TrustySimpleFTDemoRobot();
		TrustySimpleAlgorithm trusty = new TrustySimpleAlgorithm(robot);
		
		TrustyView view = new TrustyView(trusty);
		TrustyCommands commands = new TrustyCommands(trusty);
				
		java.awt.Frame f = new java.awt.Frame(className);
		f.setLayout(new java.awt.BorderLayout());
		f.add("North", view);
		f.add("South", commands);
		
		f.addWindowListener(
			new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent we) {
					System.exit(0);
				}
			}
		);
		f.pack();
		f.show();
	}
// ...
}
