package de.jaetzold.art.examples;

import java.awt.Panel;
import java.awt.TextField;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

public class TrustyView extends Panel implements PropertyChangeListener {
	protected TextField stateOutput;
	
	public TrustyView() {
		stateOutput = new TextField("", 15);
		stateOutput.setEditable(false);
		add(stateOutput);
	}
	
	public void propertyChange(PropertyChangeEvent pce) {
		if(pce.getSource() instanceof Trusty
				&& pce.getPropertyName().equals("state")
				&& pce.getNewValue() instanceof Number) {
			
			String stateName = "";
			switch(((Number)pce.getNewValue()).intValue()) {
				case Trusty.STOP:
					stateName = "stop";
					break;
				case Trusty.MOVE:
					stateName = "move";
					break;
				case Trusty.AVOID_LEFT:
					stateName = "avoid left";
					break;
				case Trusty.AVOID_RIGHT:
					stateName = "avoid right";
					break;
				default:
					stateName = "unknown";
			}

			stateOutput.setText(stateName);
		}
	}
// ...
	public TrustyView(Trusty trusty) {
		this();
		de.jaetzold.util.BeanSupport.addPropertyChangeListenerFor(trusty, this);
	}
// ...
}
