package de.jaetzold.art.platform;

import java.beans.PropertyChangeListener;
import java.beans.VetoableChangeListener;

/**	This is for Peers which allow manipulation of the represented value and forward this value-change to some part of the hardware.
	*/
public interface ActuatorPeer extends	SensorPeer/*,
										PropertyChangeListener,
										VetoableChangeListener*/
{
	/**	Set the actuator to the value given as a parameter.
		@see #setValue(double,boolean)
		*/
	public void setValue(double value);
	/**	Set the actuator to the value given as a parameter.
		If waitForCompletion is false this method may return before the new value has been sent to the hardware. This way the method could return almost immediatly and informing the peer and thus the hardware may happen asynchronous.
		If for some reason the value is not o.k. for this Peer it is not required to accept the value and it is also not required to report that through an Exception.
		@param value the value this Actuator should have.
		@param waitForCompletion whether this method may set the value asynchronous.
		@see #setValue(double)
		*/
	public void setValue(double value, boolean waitForCompletion);
// we wan't events from an actuator to be informed whenever the actuator
// reaches a specific value described by the eventdescriptor
// wouldn't it be better if we'd just provide a sensorport for this?
/*	public void enableEvent(ActuatorEventDescriptor eventDescriptor);
	public void disableEvent(ActuatorEventDescriptor eventDescriptor);
*/
}
