package de.jaetzold.art.platform;

import de.jaetzold.art.SensorEventDescriptor;

public abstract class ForwardingSensorPeer extends BaseSensorPeer {
	private static de.jaetzold.util.Debug debug =
			new de.jaetzold.util.Debug("de.jaetzold.art.ForwardingSensorPeer");
	
	protected SensorPeer target;
	public ForwardingSensorPeer(SensorPeer target) {
		this.target = target;
	}
	
	public double getValue() {
		return target.getValue();
	}
	
	public boolean isConnected() {
		return target.isConnected();
	}
	public boolean getDeliversFloatingPoint() {
		return target.getDeliversFloatingPoint();
	}

	public void enableEvent(SensorEventDescriptor eventDescriptor) {
		target.enableEvent(eventDescriptor);
	}
	public void disableEvent(SensorEventDescriptor eventDescriptor) {
		target.disableEvent(eventDescriptor);
	}

	// do not forward these rest of the method-calls because
	// they would affect the source of events
}
