package de.jaetzold.art.platform;

public interface LightSensorPeer extends SensorPeer {
	// TBD: would it be better to define method(s) like this:
	// public boolean isInMeasurableRange();
	// public Range getMeasurableRange();
	/** This returns the smallest value which is still accurate (considering the precision).
		That gives a LightSensor the chance to tell that the Light-Level is out of the range it can measure with sufficient precision. A value of 0 for example would usually not be a real measured value, except for the case where the measurableMin<=precision.
		*/ 
	public double getMeasurableMin();
	/** Same principle as for measurableMin.
		@see #getMeasurableMin()
		*/
	public double getMeasurableMax();
}
