package de.jaetzold.art.platform;

/**	A MotorPeer gives direct access to the properties on, backward and power. This way it can be distinguished whether a motor is forward or backward and what power it has even when it is off. This is impossible if these states are mapped to a single raw-value like <code>Motor</code> does it when only an <code>ActuatorPeer</code> is available.
	@see de.jaetzold.art.Motor
	*/
public interface MotorPeer extends ActuatorPeer {
	/**	Switch the motor on or off depending on the value of <code>on</code>.
		*/
	public void setOn(boolean on);
	public boolean isOn();
	/**	Set the direction of the motor. Note that setting the direction does not imply switching the motor on.
		@see #setOn(boolean)
		*/
	public void setBackward(boolean backward);
	public boolean getBackward();
	/**	Set the power of the motor. Note that setting the power does not imply switching the motor on.
		@see #setOn(boolean)
		*/
	public void setPower(double power);
	public double getPower();
}
