package de.jaetzold.art.platform.lego;

import de.jaetzold.art.platform.PacketChecker;
import de.jaetzold.art.platform.PacketInputStream;

import java.io.InputStream;
import java.io.IOException;

import de.jaetzold.util.StringObservable;	// just for debug-messages

public class RCXPacketInputStream extends PacketInputStream {
	protected PacketChecker packetChecker;
	public PacketChecker getPacketChecker() {
		return packetChecker;
	}
	public void setPacketChecker(PacketChecker packetChecker) {
		this.packetChecker = packetChecker;
		setPacketDataFilter(new PacketDataComplementFilter() {
				public boolean isDataComplete(	byte[] packet,
												int packetLen,
												byte[] readBuffer,
												int readBOff,
												int readBLen) {
					return RCXPacketInputStream.this.packetChecker.isComplete(packet, packetLen);
				}
		});
	}

	public RCXPacketInputStream(InputStream target, byte[] header) {
		super(	target,
				header,
				new PacketDataComplementFilter(),
				new PacketTrailerChecksumByteChecker());
	}
}
