package de.jaetzold.util;

import java.beans.PropertyChangeListener;

public class BeanSupport {
	/**
		@exception NullPointerException if target is null
		*/
	public static void addPropertyChangeListenerFor(Object target,
													PropertyChangeListener l)
	{
		try {
			java.lang.reflect.Method m =
					target.getClass().getMethod("addPropertyChangeListener",
								new Class[] {PropertyChangeListener.class});
			m.invoke(target, new Object[]{l});
		} catch(Exception e) {
			throw new java.util.MissingResourceException(
							"The target doesn't accept this listener.",
							target.getClass().getName(),
							"PropertyChangeListener");
		}
	}
	
	/**
		@exception NullPointerException if target is null
		*/
	public static void removePropertyChangeListenerFor(Object target,
													PropertyChangeListener l)
	{
		try {
			java.lang.reflect.Method m =
					target.getClass().getMethod("removePropertyChangeListener",
								new Class[] {PropertyChangeListener.class});
			m.invoke(target, new Object[]{l});
		} catch(Exception e) {
			throw new java.util.MissingResourceException(
							"The target doesn't accept this listener.",
							target.getClass().getName(),
							"PropertyChangeListener");
		}
	}
}
