package de.jaetzold.util;

public interface BooleanConversion {
	/** Tells whether this instance will in the future produce the same result for the same arguments.
		This can be false first and then true at a later time, but it is not legal to return false here after a return of true in the past, because the true answer before was wrong then.
		@return true if this instance guarantees, that any further call to convertToLong/DoubleValue() with the same arguments returns the same result
	*/
	public boolean isCacheable();
	public boolean convertToBoolean(double value);
}
