package de.jaetzold.util;

/**	Utilityklasse zum kopieren von Arrays. */
public class Copy {
    /**	Macht eine komplette Kopie des uebergebenen Arrays. */
    public static byte[] array(byte[] from) {
        return byteArray(from, 0, from.length);
    }

    /**	Liefert eine Kopie von dem spezifizierten Subarray des uebergebenen Arrays.
    @param from das Array welches kopiert werden soll.
    @param offset der index in from ab dem kopiert werden soll.
    @param length die Anzahl Elemente die kopiert werden soll.
    @exception ArrayIndexOutOfBoundsException if the specified region is not completely in from.
    	*/
    public static byte[] array(byte[] from, int offset, int length) {
        byte[] result = new byte[length];
        System.arraycopy(from, offset, result, 0, length);
        return result;
    }
}
