package de.jaetzold.util;

// TBD: This is almost the same as CombinedRange. Implement a superclass

public class DifferenceRange implements Range {
	private boolean isCacheableCache = false;
	public boolean isCacheable() {
		if(!isCacheableCache) {
			if(ranges!=null) {
				for(int i=0; i<ranges.length; i++) {
					if(ranges[i] == null
							|| !ranges[i].isCacheable()) {
						return false;
					}
				}
				isCacheableCache = true;
			}
		}
		return isCacheableCache;
	}
	
	private Range[] ranges;
	
	// null-references contain no values
	public DifferenceRange(Range base, Range minus) {
		ranges = new Range[] {base, minus};
	}
	
	public boolean contains(double value) {
		boolean result = false;
		// range[0](base) has to contain the value and range[1](minus) not!
		if(ranges[0] != null) {
			result = ranges[0].contains(value);
		}
		if(result && ranges[1] != null) {
			result = result && !ranges[1].contains(value);
		}
		return result;
	}
}
