package de.jaetzold.util;

// TBD: This is almost the same as CombinedRange. Implement a superclass

public class IntersectionRange implements Range {
	private boolean isCacheableCache = false;
	public boolean isCacheable() {
		if(!isCacheableCache) {
			if(ranges!=null) {
				for(int i=0; i<ranges.length; i++) {
					if(ranges[i] == null
							|| !ranges[i].isCacheable()) {
						return false;
					}
				}
				isCacheableCache = true;
			}
		}
		return isCacheableCache;
	}
	
	private Range[] ranges;
	
	public IntersectionRange(Range theOne, Range theOther) {
		this(new Range[] {theOne, theOther});
	}
	
	public IntersectionRange(Range[] ranges) {
		this.ranges = new Range[ranges.length];
		System.arraycopy(ranges, 0, this.ranges, 0, ranges.length);
	}
	
	// null-references contain no values
	public boolean contains(double value) {
		for(int i=0; i<ranges.length; i++) {
			if(ranges[i] == null || ranges[i].contains(value)) {
				return false;
			}
		}
		return true;
	}
}
