package de.jaetzold.util;

/** This exception is used to indicate that the called method would have to
	wait for some condition to complete it's execution. E.g. that a <code>read()</code>
	would have to wait for data to be available.
	*/
public class NoImmediateExecutionException extends Exception {
	/** Creates a new NoImmediateExecutionException without a detail message. */
    public NoImmediateExecutionException() { }
    /** Creates a new NoImmediateExecutionException with <code>message</code> as detail message. */
    public NoImmediateExecutionException(String message) {
        super(message);
    }
}
