package de.jaetzold.util;

public class RequeueTask	implements	de.jaetzold.util.Task
{
	private Task target;
	private Queue queue;
	public RequeueTask(Task target, Queue queue) {
		this.target = target;
		this.queue = queue;
	}

	public Event perform()
			throws Exception
	{
		Event result = null;
		try {
			result = target.perform();
		} finally {
			if(debug) {
				System.out.println(getClass().getName() +": "
									+"requeueing " +target);
			}
			if(active) {
				queue.post(this);
			}
		}
		return result;
	}
	
	// a better way would be just to remove this task from the Queue, but
	// this task isn't always in the Queue ...
	private boolean active = true;
	public void stop() {
		active = false;
	}
	
	private static boolean debug;
	static {
		String v = null;
		v = System.getProperty("de.jaetzold.util.RequeueTask"+".debug");
		if(v==null) {
			v = System.getProperty("de.jaetzold.util"+".debug");
		}
		if(v==null) {
			v = System.getProperty("debug");
		}
		// results to false if v!="true" (ignoring case)
		debug = Boolean.valueOf(v).booleanValue();
	}
}
