package de.jaetzold.util;

import java.util.Observable;
import java.util.StringTokenizer;

/**	Ein String der auch ein Observable ist. Ein String ist diese Klasse noch nicht, denn bisher sind nur 2 Statische, String-bezogene Utilityfunktionen implementiert.
*/
public class StringObservable extends Observable {
	private static boolean debug;
    /**	Liefert die Bytes aus buf als String von Hex-Zahlen.
    	Calls <code>toHexString(buf, 0, buf.length, "")</code>
		@see #toHexString(byte[], int, int, String)
    	*/
    public static String toHexString(byte[] buf) {
        return toHexString(buf, 0, buf!=null?buf.length:0, " ");
    }

    /** Liefert die Bytes aus buf als String von Hex-Zahlen. Es werden nur <code>length</code> Bytes ab dem Index <code>offset</code> genommen.
    Jedes Byte wird durch 2 Hex-Ziffern dargestellt, mit <code>separator</code> als Zwischenraum zwischen den Bytes.
        */
    public static String toHexString(byte[] buf,
                                     int offset,
                                     int length,
                                     String separator){
        StringBuffer hexString = new StringBuffer();
		if(buf == null) {
			return hexString.toString();
		}
		if(separator == null) {
			separator = " ";
		}
        for(int i=offset; i<buf.length && i-offset<length; i++) {
            int tmp = (int)buf[i];
            if(tmp < 0) {
                tmp+=256;
            }
            hexString.append(Integer.toHexString(tmp));
            if((hexString.length()-(i-offset)*separator.length())%2 != 0) {
                hexString.insert((i-offset)*(2+separator.length()), '0');
            }
            if(i<buf.length-1)
                hexString.append(separator);
        }
        return hexString.toString();
    }
	
	public static byte[] toHexBytes(String hexString) {
	    StringTokenizer tok = new StringTokenizer(hexString);
        String sub = "";
        while(tok.hasMoreTokens()) {
            sub = sub + tok.nextToken();
        }
        byte[] result = new byte[sub.length()/2];
        if(sub.length()%2 != 0) {
            throw new IllegalArgumentException("Odd number of characters in hexString.");
       	}
        
        for(int i=0; sub.length() >= i*2 + 2; i++) {
            result[i] = (byte)Short.parseShort(sub.substring(i*2, i*2 +2), 16);
        }
		if(debug) System.out.println("StringObservable"
									+": " +StringObservable.toHexString(result));
		return result;
	}
}
