package de.jaetzold.util;

public class ValueLinkedStateDecider extends LinkedStateDecider {	
	public double nextStateValue(double actualState, double value) {
		// needs no sync/copy to be Thread-safe
		// because first and second cannot be set to null once there had
		// been assigned a non-null value to them
		if(second != null) {
			if(first != null) {
				return second.nextStateValue(actualState, 
							first.nextStateValue(actualState, value));
			} else {
				return second.nextStateValue(actualState, 0);
			}
		} else {
			return 0;
		}
	}

	public ValueLinkedStateDecider() {
		// don't initialize with deciders!
	}
	public ValueLinkedStateDecider(StateDecider first, StateDecider second) {
		super(first, second);
	}
}
